package de.lmu.ifi.pst.uwe4jsf.persistence.hibernate;

import java.io.Serializable;
import java.util.List;

import org.hibernate.Session;

import de.lmu.ifi.pst.uwejsf.framework.AbstractPersistenceManager;
import de.lmu.ifi.pst.uwejsf.framework.AbstractUWEContextFactory;
import de.lmu.ifi.pst.uwejsf.framework.UWEJSFRuntimeException;



public class HibernatePersistenceManager extends AbstractPersistenceManager {
	
	
	public Object loadByKey(String className, Object key) {

		String javaName = AbstractUWEContextFactory.getCurrentInstance()
				.getReverseTypeMapping(className);
		Class<?> cl = null;
		try {
			cl = Class.forName(javaName);
		} catch (ClassNotFoundException e) {
			throw new UWEJSFRuntimeException(
					"PersistenceManager.loadByKey() failed!", e);
		}
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();

		session.beginTransaction();

		Object result = session.get(cl, (Serializable) key);
		session.getTransaction().commit();
		return result;
	}

	public void saveObject(Object obj) {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();

		session.beginTransaction();

		if (!session.contains(obj))
			session.saveOrUpdate(obj);
		session.getTransaction().commit();

	}

	public void deleteObject(Object obj) {
		// TODO Auto-generated method stub

	}

	@Override
	protected List<?> queryByExpressionLanguage(String elementClassName,
			String expression, String expressionLanguage) {

		Session session = HibernateUtil.getSessionFactory().getCurrentSession();

		session.beginTransaction();

		List<?> result = session.createQuery(expression).list();

		session.getTransaction().commit();

		return result;
	}
}
